package xyz.tbvns;

import java.util.ArrayList;
import java.util.List;

public class XmlUtils {
    public static String beautify(String xml) {
        StringBuilder result = new StringBuilder();
        for (char c : xml.toCharArray()) {
            if (c == '<') {
                result.append("\n").append(c);
            } else if (c == '>') {
                result.append(c).append("\n");
            } else {
                result.append(c);
            }
        }
        String newResult = result.toString();
        char[] data = newResult.toCharArray();
        StringBuilder finalResult = new StringBuilder();
        for (int i = 1; i < newResult.length() - 1; i++) {
            char c1 = data[i];
            char c2 = data[i+1];
            if (!(c1 == '\n' && c2 != '\n')) {
                finalResult.append(c1);
            }
        }

        return finalResult.toString();
    }

    public static String gamesheetToXML(String data) {
        //TODO: Replace that with custom reader
        String[] lines = data
                .replace(" ", "")
                .split("\n");
        StringBuilder newData = new StringBuilder();
        for (int i = 0; i < lines.length; i++) {
            String line = lines[i];
            if (line.contains("<key>")) {
                line = line.replace("<key>", "").replace("</key>", "");
                lines[i] = "";
                String modify = lines[i + 1];
                List<String> usableData = new ArrayList<>();
                for (String s : modify.split("<")) {
                    for (String s1 : s.split(">")) {
                        usableData.add(s1);
                    }
                }
                usableData.remove(0);
                if (usableData.size() == 3) {
                    usableData.set(0, line);
                    usableData.set(2, line);
                    newData.append("<" + usableData.get(0) + ">")
                           .append(usableData.get(1))
                           .append("</" + usableData.get(2) + ">")
                           .append("\n");
                } else if (line.equals("textureRotated")) {
                    if (lines[i+1].equals("<true/>")) {
                        newData.append("<textureRotated>true</textureRotated>\n");
                    } else {
                        newData.append("<textureRotated>false</textureRotated>\n");
                    }
                } else if (lines[i+1].equals("<dict>")) {
                    newData.append("<dict>\n")
                           .append("<name>" + line + "</name>\n");
                }
                i++;
            } else {
                if (line.equals("<plistversion=\"1.0\">")) {
                    line = "<plist version=\"1.0\">";
                }
                newData.append(line + "\n");
            }
        }
        return newData.toString();
    }
}
