package xyz.tbvns.ui.Elements;

import com.badlogic.gdx.Gdx;
import imgui.ImGui;
import imgui.flag.ImGuiWindowFlags;
import org.lwjgl.PointerBuffer;
import org.lwjgl.util.tinyfd.TinyFileDialogs;
import xyz.tbvns.Editor.ModelsManager;
import xyz.tbvns.Models.Animation;
import xyz.tbvns.Models.GDModel;
import xyz.tbvns.ui.Element;
import xyz.tbvns.ui.Renderable;

import javax.swing.filechooser.FileNameExtensionFilter;
import java.awt.*;
import java.io.File;
import java.nio.ByteBuffer;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;

public class ModelsList implements Element {
    @Override
    public void render() {
        ImGui.begin("Menu", ImGuiWindowFlags.NoDecoration | ImGuiWindowFlags.NoMove | ImGuiWindowFlags.NoBringToFrontOnFocus);
        ImGui.setWindowSize(200, Gdx.graphics.getHeight() - 19 - 200);
        ImGui.setWindowPos(0, 19);

        ImGui.beginTabBar("animationBar");
        modelsTab();
        ImGui.endTabBar();


        ImGui.end();
    }

    public void modelsTab() {
        ImGui.beginTabItem("Assets");
        loadButton();
        animationButtons();
        ImGui.endTabItem();
    }

    public void loadButton() {
        if (ImGui.button("Load an animation")) {
            try {
                String path = TinyFileDialogs.tinyfd_selectFolderDialog("Select animation folder:", System.getProperty("user.home"));
                if (path!=null) {
                    ModelsManager.addAnimated(
                            new File(
                                    path
                            )
                    );
                }
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
        if (ImGui.button("Load a model")) {
            try {
                FileDialog fd = new FileDialog((Frame) null, "Save File", FileDialog.SAVE);
                fd.setFile("*.obj");
                fd.setFilenameFilter((dir, name) -> {
                    if (name.endsWith(".obj")) {
                        return true;
                    }
                    return false;
                });
                fd.setMode(FileDialog.LOAD);
                fd.setVisible(true);

                if (fd.getFile() != null) {
                    ModelsManager.addModel(new File(fd.getDirectory() + "/" + fd.getFile()));
                }
            } catch (Exception e) {
                throw new RuntimeException(e);
            }
        }
    }

    public void animationButtons() {
        List<Renderable> renderables = new ArrayList<>();
        for (GDModel model : ModelsManager.models) {
            renderables.add(model);
        }
        for (Animation animation : ModelsManager.animations) {
            renderables.add(animation);
        }
        ImGui.text("Available models:");
        for (Renderable renderable : renderables) {
            renderable.render();
        }
    }
}
