package xyz.tbvns.ui.Elements;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.graphics.g3d.Model;
import com.badlogic.gdx.graphics.g3d.ModelInstance;
import imgui.ImGui;
import imgui.extension.imguizmo.ImGuizmo;
import imgui.flag.ImGuiWindowFlags;
import imgui.type.ImString;
import xyz.tbvns.Editor.ModelsManager;
import xyz.tbvns.Models.GDModel;
import xyz.tbvns.ui.Element;

import java.util.HashMap;
import java.util.Random;

public class Timeline implements Element {
    private HashMap<ModelInstance, String> name = new HashMap<>();
    private HashMap<ModelInstance, String> id = new HashMap<>();

    @Override
    public void render() {
        ImGui.begin("TimeMenu", ImGuiWindowFlags.NoDecoration | ImGuiWindowFlags.NoMove | ImGuiWindowFlags.NoBringToFrontOnFocus);
        ImGui.setWindowSize(Gdx.graphics.getWidth(), 201);
        ImGui.setWindowPos(0, Gdx.graphics.getHeight() - 201);
        //TODO: replace every model with an object that contains the following information:
        // - start and en frame
        // - FPS for animation
        // - keyframes for positions and scale
        // - name
        // - id (unique)
        // - more thing if I have an idea later
        for (ModelInstance model : ModelsManager.getLoadedModels()) {
            ImString string;
            if (name.containsKey(model)) {
                string = new ImString(name.get(model));
            } else {
                string = new ImString(((GDModel) model.userData).getName() + "-" + new Random().nextInt(1000, 9999));
                id.put(model, "##" + new Random().nextInt(1000, 9999999));
            }
            ImGui.inputText(id.get(model), string);
            name.put(model, new String(string.getData()));
        }

        ImGui.end();
    }
}
