package xyz.tbvns.ui.Windows;

import imgui.ImGui;
import imgui.flag.ImGuiInputTextFlags;
import imgui.flag.ImGuiWindowFlags;
import imgui.type.ImString;
import xyz.tbvns.DataManager;
import xyz.tbvns.Decoder;
import xyz.tbvns.GeometryDash.LevelUtils;
import xyz.tbvns.LevelInfo;
import xyz.tbvns.Main;
import xyz.tbvns.Objects.Level;
import xyz.tbvns.ui.Element;
import xyz.tbvns.ui.UIManager;

import java.io.IOException;
import java.util.List;

public class LevelSelector implements Element {
    private static List<Level> levelList;
    static {
        try {
            levelList = DataManager.getLevels();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public static void update() {
        try {
            levelList = DataManager.getLevels();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public void render() {
        ImGui.begin("Load a level:", ImGuiWindowFlags.NoCollapse);
        ImString string = new ImString();
        ImGui.inputTextWithHint("##", "Search...", string, ImGuiInputTextFlags.AutoSelectAll);
        for (Level level : levelList) {
            if (level.getName().toLowerCase().contains(string.get().toLowerCase()) && ImGui.button(level.getName())) {
                try {
                    Main.modelCache = LevelUtils.generateModelCache(level);
                    LevelInfo.setLevel(level);
                    LevelInfo.setLevelString(Decoder.decodeLevel(level.getEncodedLevelString()));
                    UIManager.getActiveUI().put(getClass(), false);
                } catch (Exception e) {
                    throw new RuntimeException(e);
                }
            }
        }
        ImGui.end();
    }
}
