package xyz.tbvns.ui.Windows;

import com.badlogic.gdx.Gdx;
import com.badlogic.gdx.math.Vector3;
import imgui.ImGui;
import imgui.flag.ImGuiWindowFlags;
import xyz.tbvns.Editor.ModelsManager;
import xyz.tbvns.ui.Element;

public class ObjectEdit implements Element {
    @Override
    public void setup() {
    }

    @Override
    public void render() {
        ImGui.begin("Edit model:", ImGuiWindowFlags.NoMove | ImGuiWindowFlags.NoResize);
        ImGui.setWindowPos(Gdx.graphics.getWidth() - ImGui.getWindowWidth(), 19);

        if (ImGui.button("-100")) {
            move(axis.X, -100);
        }
        ImGui.sameLine();
        if (ImGui.button("-10")) {
            move(axis.X, -10);
        }
        ImGui.sameLine();
        if (ImGui.button("-5")) {
            move(axis.X, -5);
        }
        ImGui.sameLine();
        if (ImGui.button("-1")) {
            move(axis.X, -1);
        }
        ImGui.sameLine();
        ImGui.text("X");
        ImGui.sameLine();
        if (ImGui.button("+1")) {
            move(axis.X, 1);
        }
        ImGui.sameLine();
        if (ImGui.button("+5")) {
            move(axis.X, 5);
        }
        ImGui.sameLine();
        if (ImGui.button("+10")) {
            move(axis.X, 10);
        }
        ImGui.sameLine();
        if (ImGui.button("+100")) {
            move(axis.X, 100);
        }



        if (ImGui.button("-100##2")) {
            move(axis.Y, -100);
        }
        ImGui.sameLine();
        if (ImGui.button("-10##2")) {
            move(axis.Y, -10);
        }
        ImGui.sameLine();
        if (ImGui.button("-5##2")) {
            move(axis.Y, -5);
        }
        ImGui.sameLine();
        if (ImGui.button("-1##2")) {
            move(axis.Y, -1);
        }
        ImGui.sameLine();
        ImGui.text("Y");
        ImGui.sameLine();
        if (ImGui.button("+1##2")) {
            move(axis.Y, 1);
        }
        ImGui.sameLine();
        if (ImGui.button("+5##2")) {
            move(axis.Y, 5);
        }
        ImGui.sameLine();
        if (ImGui.button("+10##2")) {
            move(axis.Y, 10);
        }
        ImGui.sameLine();
        if (ImGui.button("+100##2")) {
            move(axis.Y, 100);
        }



        if (ImGui.button("-100##3")) {
            move(axis.Z, -100);
        }
        ImGui.sameLine();
        if (ImGui.button("-10##3")) {
            move(axis.Z, -10);
        }
        ImGui.sameLine();
        if (ImGui.button("-5##3")) {
            move(axis.Z, -5);
        }
        ImGui.sameLine();
        if (ImGui.button("-1##3")) {
            move(axis.Z, -1);
        }
        ImGui.sameLine();
        ImGui.text("Z");
        ImGui.sameLine();
        if (ImGui.button("+1##3")) {
            move(axis.Z, 1);
        }
        ImGui.sameLine();
        if (ImGui.button("+5##3")) {
            move(axis.Z, 5);
        }
        ImGui.sameLine();
        if (ImGui.button("+10##3")) {
            move(axis.Z, 10);
        }
        ImGui.sameLine();
        if (ImGui.button("+100##3")) {
            move(axis.Z, 100);
        }
        ImGui.end();
    }

    public void move(axis axis, int d) {
        Vector3 pos = ModelsManager.getSelectedModelInstance().transform.getTranslation(Vector3.Zero);
        if (axis == ObjectEdit.axis.X) {
            ModelsManager.getSelectedModelInstance().transform.setToTranslation(pos.x + d, pos.y, pos.z);
        } else if (axis == ObjectEdit.axis.Y) {
            ModelsManager.getSelectedModelInstance().transform.setToTranslation(pos.x, pos.y + d, pos.z);
        } else if (axis == ObjectEdit.axis.Z) {
            ModelsManager.getSelectedModelInstance().transform.setToTranslation(pos.x, pos.y, pos.z + d);
        }
    }

    public enum axis {
        X, Y, Z
    }
}
