#version 330 core

// Uniforms
uniform mat4 u_projTrans;        // Projection-view transformation matrix
uniform mat4 u_modelTrans;       // Model transformation matrix (new)
uniform float u_outlineThickness; // Thickness of the outline

// Vertex attributes
in vec3 a_position; // Vertex position
in vec3 a_normal;   // Vertex normal

void main() {
    // Calculate the transformed position with model transformation and outline thickness
    vec3 scaledPosition = a_position + a_normal * u_outlineThickness;

    // Apply both the model transformation and the projection-view transformation
    gl_Position = u_projTrans * u_modelTrans * vec4(scaledPosition, 0.9);
}
